"use strict";var fs=require("fs"),ini=require("ini"),zip=require("node-zip"),to_json=require("xmljson").to_json,to_xml=require("xmljson").to_xml,sqlite3=require("sqlite3").verbose(),path=require("path"),util=require("util"),fse=require("fs-extra"),appname="Control Dashboard",regexp_ini=/\.CPB$/i,regexp_xml=/\.XML$/i,regexp_icc=/\.ICC$/i,regexp_zip=/([^\\/]+)\.EMX$/i,regexp_emx=/^(\S+)\s+(\S+)/i,file_permission="0777",format_version="1.0.0";exports.format_version=format_version,exports.getUserDoc=function(){return getUserDoc()},exports.getLogDir=function(){return getLogDir()},exports.getUserEmxDir=function(){return getUserEmxDir()},exports.addPrinter=function(e,r,n,i,t,a,o,d,s,u){getModelName(e,r,function(l,f){return l?void u(l):void addNewPrinter(e,r,n,i,t,a,o,d,s,function(i){return i?void u(i):void createDummyBanks(e,r,n,function(e){return e?void u(e):void u(e)})})})},exports.deletePrinter=function(e,r,n){var i="DELETE FROM printers WHERE id = '"+r+"'";e.run(i,function(i){return i?void n(i):(deletePrinterStatus(e,r,function(e){e&&n(e)}),deleteParams(e,r,function(e){e&&n(e)}),void n(i))})},exports.updatePrinter=function(e,r,n,i,t,a,o,d){var s="UPDATE printers SET ",u=[];null!==n&&(n=n.replace(/'/g,"''"),u.push("name = '"+n+"'")),null!==i&&u.push("net_config = '"+JSON.stringify(i)+"'"),null!==t&&u.push("firm_ver = '"+JSON.stringify(t)+"'"),null!==a&&u.push("note = '"+a+"'"),o>=0&&u.push("sort_id = "+o),s+=u.join(","),s+=" WHERE id = '"+r+"'",e.exec(s,function(e){return e?void d(e):void d(e)})},exports.getPrinterList=function(e,r){var n="SELECT printers.id, printers.name, que_name, models.name as model_name, models.detail as model_detail, sort_id, printers.net_config, printers.firm_ver FROM printers, models WHERE printers.model_id = models.id ",i=[];e.serialize(function(){e.each(n,function(e,r){var n=JSON.parse(r.net_config),t=JSON.parse(r.model_detail),a=JSON.parse(r.firm_ver);i.push({serial_no:String(r.id),name:r.name,que_name:r.que_name,model_name:r.model_name,readable_model_name:t.Series,adapter_info:n,sort_id:r.sort_id,firm_ver:a})},function(e,n){r(e,i)})})},exports.getPrinterInfo=function(e,r,n){var i="SELECT printers.name, printers.model_id, models.name AS modelname, net_config FROM printers, models WHERE printers.model_id = models.id AND printers.id= '"+r+"'";e.get(i,function(e,r){return e?void n(e,void 0):"undefined"==typeof r?void n(new Error("can not get printer id.")):void n(e,r.name,r.model_id,r.modelname,JSON.parse(r.net_config))})},exports.addPrinterStatus=function(e,r,n,i,t){var a="INSERT INTO statuses(printer_id, status, prev_status, parts) VALUES(?, ?, ?, ?)",o=e.prepare(a,r,JSON.stringify(n),JSON.stringify(n),JSON.stringify(i),function(e){return e?void t(e):void o.run(function(e){e&&t(e),o.finalize(),t(null)})})},exports.getPrinterStatus=function(e,r,n){var i="SELECT prev_status, status FROM statuses WHERE printer_id = ?",t="",a="",o=e.prepare(i,r,function(e){return e?(console.error(e.message),void n(e)):void o.each(r,function(e,r){t=r.status,a=r.prev_status},function(e,i){i>0?n(e,JSON.parse(t),JSON.parse(a)):n(new Error("Printer not found: "+r),null,null)})})},exports.updatePrinterStatus=function(e,r,n,i,t){var a="UPDATE statuses SET prev_status = status, status = '"+JSON.stringify(n);null!=i&&(a+="', parts = '"+JSON.stringify(i)),a+="' WHERE printer_id =  '"+r+"'",e.serialize(function(){e.run(a,function(e){return e?void t(e):void t(e)})})},exports.extractEMX=function(e,r,n,i){var t=getUserTemp();if(!regexp_zip.test(e))return void i(new Error("can't open file."));var a=regexp_zip.exec(e),o=r||a[1],d=t+"/"+o;fs.stat(d,function(r,a){var s=r,u=fs.readFileSync(e);console.log(e+" is opend\n");var l=null,f=null,m={},p={base64:!1,checkCRC32:!0,dir:!1};try{var c=new JSZip(u,p)}catch(v){return void i(new Error("can't read zip file."))}for(var _ in c.files){var E=c.files[_];if(E.name){console.log("file ="+E.name);var g=path.join(d,E.name);regexp_ini.test(g)?l=ini.parse(E.asText()):regexp_xml.test(g)?f=E.asText():regexp_icc.test(g)&&(m[E.name.toUpperCase()]=g)}}if(null!=l&&null!=f&&Object.keys(m).length>0){var S=[];to_json(f,function(r,u){if(r)return void i(r);if(void 0==u.Model.MediaInfo.ID)return void i(new Error("illegal emx."));var f=u.Model.EMXFileInfo.Publish;if("All"!==f&&"SEC_Eval"!==f)return void i(new Error("Invalid publisher."));delete l.Setting01.MediaTable,delete l.Setting01.No;var p=l.Setting01;p.MediaID=u.Model.MediaInfo.ID,p.TimeStamp=l.Base.MakeTime,p.version=l.Base.Version,p.bankNo="0",delete u.Model.MediaInfo.CPBFileName;var v={};if(v=u.Model.MediaInfo,v.ModelInfo={},v.ModelInfo.Name=u.Model.Name,v.ModelInfo.Series=u.Model.Series,v.ModelInfo.InkType=u.Model.InkType,v.version=u.Model.EMXFileInfo.SystemVersion,v.TimeStamp=u.Model.EMXFileInfo.TimeStamp,v.bankNo="0",v.cpsName=p.MediaName,null!=u.Model.MediaInfo.ModeInfo.PMI){var _=u.Model.MediaInfo.ModeInfo.PMI,E=u.Model.MediaInfo.ModeInfo.ICCProfileName.toUpperCase();v.allPmi=_,S.push({name:E,path:m[E],PMI:_})}else{var g=[],N=u.Model.MediaInfo.ModeInfo;for(var M in N){var _=N[M].PMI,E=N[M].ICCProfileName.toUpperCase();g.push(_),S.push({name:E,path:m[E],PMI:_})}v.allPmi=g.join()}if(v.TransferInfo=u.Model.TransferInfo,s)try{mkdirAllSync(o,file_permission,t)}catch(y){return void i(y)}else if(!a.isDirectory())return void i(new Error("can't create directory."));for(var x in c.files){var O=c.files[x];if(O.name){if(console.log("file ="+O.name),O.dir)continue;var I=path.join(d,O.name),T=path.dirname(O.name);try{mkdirAllSync(T,file_permission,d),fs.writeFileSync(I,O.asNodeBuffer())}catch(y){return void i(y)}}}n&&copyEmx(e,function(e){return e?void i(e):void 0}),i(r,o,p,v,S)})}else i(new Error("can't parse emx."))})},exports.updateMechaParam=function(e,r,n,i,t){var a=void 0==i.MediaID?0:i.MediaID;i.bankNo=n;var o="UPDATE params SET value = ?, media_id = ? WHERE printer_id = ? AND bank_no = ? AND param_type_id = 1",d=e.prepare(o,JSON.stringify(i),a,r,n,function(i){return i?void t(i):void d.run(function(i){if(i)return void t(i);var o="UPDATE params SET media_id = '"+a+"' WHERE printer_id = '"+r+"' AND bank_no = "+n;e.exec(o,function(e){return e?void t(e):void 0}),t(i)})})},exports.updateParams=function(e,r,n,i,t,a,o,d,s,u){console.log("model id = "+r+", serial no = "+n+", bank no = "+i),updateParam(e,r,n,i,0,a,function(t){return t?void u(t):void updateParam(e,r,n,i,1,o,function(t){return t?void u(t):void updateParam(e,r,n,i,2,d,function(t){return t?void u(t):void updateParam(e,r,n,i,3,s,function(e){return e?void u(e):void u(e)})})})})};var searchMediaLibraryQuery="SELECT * FROM \n(\n  SELECT printer_id, bank_no, media_id, param_type_id, name, value\n  FROM (SELECT * FROM params WHERE printer_id = 0 and bank_no <> 0 and param_type_id = ?)\n  LEFT OUTER JOIN models ON model_id = models.id\n)\nWHERE name = ? and media_id = ?;";exports.searchMechaParamFromLibrary=function(e,r,n,i){e.get(searchMediaLibraryQuery,1,r,n,function(e,r){if(e)return i(e);if(r){var n=JSON.parse(r.value);i(null,n)}else i("Not Found.")})},exports.searchXmlFromLibrary=function(e,r,n,i){e.get(searchMediaLibraryQuery,0,r,n,function(e,r){if(e)return i(e);if(r){var n=JSON.parse(r.value),t=n.emxtitle;getEmxCtrlFile(t,function(e,r){return e?i(e):void i(null,r)})}else i("Not Found.")})},exports.searchIccFromLibrary=function(e,r,n,i,t,a){e.get(searchMediaLibraryQuery,0,r,n,function(o,d){return o?a(o):void e.get(searchMediaLibraryQuery,2,r,n,function(e,r){if(e)return a(e);try{var n=JSON.parse(d.value),o=n.emxtitle,s=getUserTemp(),u=path.resolve(s,o),l=JSON.parse(r.value),f=l.ModeInfo,m=getIccProfilePath(u,f,i,t);return m?a(null,m):a(new Error("icc profile not found."))}catch(p){a(new Error(p))}})})};var getIccProfilePath=function(e,r,n,i){var t=0==i?"ICCProfileName":"ICCProfileNameRGB";if(r[0]){for(var a in r){var o=r[a];if(o.PMI===n){var d=o[t];return d?path.resolve(e,d):(console.error("icc profile not found."),null)}}console.error("pmi#"+n+" is not exist")}else{if(r.PMI===n){var d=r[t];return d?path.resolve(e,d):(console.error("icc profile not found."),null)}console.error("pmi#"+n+" is not exist")}return null};exports.getIccProfilePath=getIccProfilePath,exports.getParam=function(e,r,n,i,t,a,o){var d="SELECT  t1.printer_id AS printer_id, t1.bank_no AS bank_no, t1.model_id AS model_id, t1.media_id AS media_id, t1.param_type_id AS param_type_id, t1.value AS value, t2.value AS orig_value FROM (SELECT * FROM params WHERE printer_id = ? AND bank_no = ? ) as t1 LEFT OUTER  JOIN (SELECT * FROM params WHERE printer_id = '0' AND media_id <> 0 ) as t2 ON t1.media_id=t2.media_id AND t1.param_type_id = t2.param_type_id and t1.model_id = t2.model_id",s=null,u={},l={},f={},m={};e.each(d,r,n,function(e,r){return e?void o(e):"undefined"==typeof r?void o(new Error("no parameter list")):void(0==r.param_type_id?m=JSON.parse(r.value):1==r.param_type_id?(u=JSON.parse(r.value),s=u.MediaName,u.version=format_version):2==r.param_type_id?(l=r.orig_value?JSON.parse(r.orig_value):{ID:"0",ModeInfo:{}},l.cpsName=s,l.bankNo=String(r.bank_no),l.version=format_version):3==r.param_type_id&&(f=JSON.parse(r.orig_value)))},function(e,r){var n;switch(i){case 0:n=m;break;case 1:n=u;break;case 2:n=l;break;case 3:n=f}a&&(filteringEmxJson(n),filteringAllPmi(n)),"XML"!=t?o(e,n):to_xml(JSON.stringify(n),function(r,n){o(e,n)})})};var getEmxCtrlFile=function(e,r){var n=getUserTemp(),i=n+"/"+e;fs.readdir(i,function(e,n){if(e)return r(e);var t=n.filter(function(e){var r=i+"/"+e;return fs.statSync(r).isFile()&&/.*\.xml$/.test(r)});if(0==t.length)return r("ctrl file not found.");var a=i+"/"+t[0];fs.readFile(a,function(e,n){r(e,n)})})};exports.getEmxCtrlFile=getEmxCtrlFile;var searchEmxInfoQuery="SELECT value, media_id FROM params\nNATURAL INNER JOIN (\n    SELECT model_id, media_id, param_type_id \n    FROM params \n    WHERE printer_id= ? AND bank_no = ? AND param_type_id = '0'\n)\nWHERE printer_id = 0;\n";exports.getPrnEmxDirName=function(e,r,n,i){e.get(searchEmxInfoQuery,r,n,function(e,r){if(e)return void i(e);var n=JSON.parse(r.value);i(null,n)})},exports.getPrnEmxAbsolutePath=function(e,r,n,i){e.get(searchEmxInfoQuery,r,n,function(e,r){if(e)return void i(e);if(!r||0==r.media_id)return i(new Error("emx is not found."));try{var n=JSON.parse(r.value),t=n.emxtitle,a=getUserTemp(),o=path.resolve(a,t);i(null,o)}catch(d){i(new Error(d))}})},exports.getPathFromUserTemp=function(e){var r=getUserTemp();return path.resolve(r,e)},exports.getParamsList=function(e,r,n,i,t){var a="SELECT detail FROM printers, models WHERE printers.id = ? AND printers.model_id = models.id",o="SELECT  t1.printer_id AS printer_id, t1.bank_no AS bank_no, t1.model_id AS model_id, t1.media_id AS media_id, t1.param_type_id AS param_type_id, t1.value AS value, t2.value AS orig_value FROM (SELECT * FROM params WHERE printer_id = ? AND bank_no > 0 ) as t1 LEFT OUTER  JOIN (SELECT * FROM params WHERE printer_id = '0' AND media_id <> 0 ) as t2 ON t1.media_id=t2.media_id AND t1.param_type_id = t2.param_type_id and t1.model_id = t2.model_id";e.get(a,r,function(a,d){if(a)return void t(a);var s={};if("undefined"==typeof d)return t(new Error("Not Found"));s=JSON.parse(d.detail);var u="{",l=0,f=null,m=null;e.each(o,r,function(e,r){if(e)return void t(e);if("undefined"==typeof r)return void t(new Error("no parameter list"));if(0==r.param_type_id)f=null,m=null;else if(1==r.param_type_id){var n=JSON.parse(r.value);f=n.MediaName,m=n.BaseMedia}else if(2==r.param_type_id){var a={};if(r.orig_value?(a=JSON.parse(r.orig_value),i&&filteringAllPmi(a)):a={ID:"0",ModeInfo:{}},a.cpsName=f,a.BaseMedia=String(m),a.bankNo=String(r.bank_no),a.version=format_version,a.allPmi=a.allPmi||"",delete a.ModeInfo,void 0!==a.TransferInfo&&delete a.TransferInfo,null!=a.ID){var o=/^\{(.+)\}/,d=o.exec(JSON.stringify(a));u+='"'+r.bank_no+'":{ "$":{"bankNo":"'+r.bank_no+'"}, '+d[1]+"},",l++}}else 3==r.param_type_id},function(e,r){if(l>0){u=u.replace(/\,$/g,"}");var i=JSON.parse(u);s.cps=i}s.count=String(l),"XML"!=n?t(e,s):to_xml(JSON.stringify(s),function(e,r){return e?void t(e):void t(e,r)})})})},exports.getFullParamsList=function(e,r,n,i,t){var a="SELECT  t1.printer_id AS printer_id, t1.bank_no AS bank_no, t1.model_id AS model_id, t1.media_id AS media_id, t1.param_type_id AS param_type_id, t1.value AS value, t2.value AS orig_value FROM (SELECT * FROM params WHERE printer_id = ? AND bank_no > 0 ) as t1 LEFT OUTER  JOIN (SELECT * FROM params WHERE printer_id = '0' AND media_id <> 0 ) as t2 ON t1.media_id=t2.media_id AND t1.param_type_id = t2.param_type_id and t1.model_id = t2.model_id",o={};e.each(a,r,function(e,r){if(e)return void t(e);if("undefined"==typeof r)return void t(new Error("no parameter list"));var n="media_"+r.bank_no;if(n in o||(o[n]={},o[n].serial_no=r.printer_id,o[n].bankNo=String(r.bank_no),o[n].ID=r.media_id,o[n].modelID=String(r.model_id),o[n].value={}),0==r.param_type_id){var i=JSON.parse(r.value);i&&(i.MediaFullName&&(o[n].value.MediaFullName=i.MediaFullName),i.datetime&&(o[n].value.datetime=i.datetime))}else 1==r.param_type_id?(o[n].value.cpb=JSON.parse(r.value),o[n].value.MediaFullName&&(o[n].value.cpb.MediaFullName=o[n].value.MediaFullName,delete o[n].value.MediaFullName)):2==r.param_type_id?(o[n].value.emx=r.orig_value?JSON.parse(r.orig_value):{ID:"0",ModeInfo:{}},o[n].value.cpb.MediaName&&(o[n].value.emx.cpsName=o[n].value.cpb.MediaName)):3==r.param_type_id&&(o[n].value.icc=null==r.orig_value?null:JSON.parse(r.orig_value))},function(e,r){i&&filteringAllPmi(o),"XML"!=n?t(e,o):to_xml(JSON.stringify(o),function(r,n){return e?void t(e):void t(e,n)})})},exports.checkTable=function(e,r,n){var i="SELECT COUNT(*)  AS count FROM "+r;e.get(i,function(e,r){return e?void n(e,void 0):"undefined"==typeof r?void n(new Error("can not get table."),void 0):void n(e,r)})},exports.searchBankNoFromMediaID=function(e,r,n,i,t){var a="SELECT * FROM params WHERE printer_id = ? AND model_id = ? AND media_id = ? AND param_type_id = 3",o=[];e.serialize(function(){e.each(a,r,n,i,function(e,r){o.push({bank_no:r.bank_no})},function(e,r){t(e,o)})})},exports.getMediaIDCount=function(e,r,n,i,t){var a="SELECT COUNT(*) AS count FROM params WHERE printer_id = '"+r+"' AND media_id = '"+i+"' AND model_id = '"+n+"'";e.get(a,function(e,r){return e?void t(e,void 0):"undefined"==typeof r?void t(new Error("can't get record"),void 0):void t(e,r)})},exports.getBankList=function(e,r,n,i){var t="SELECT DISTINCT bank_no  FROM params WHERE printer_id = ?",a=[];e.serialize(function(){e.each(t,n,function(e,r){a.push({id:r.bank_no})},function(e,r){i(e,a)})})},exports.getMediaInfo=function(e,r,n,i,t){},exports.addModel=function(e,r,n,i,t){addModelWithId(e,null,r,n,i,t)},exports.deleteAllModels=function(e,r){var n="DELETE FROM models";e.run(n,function(e){r(e)})},exports.registModels=function(e,r,n){var i=this;e.run("BEGIN",function(t){return t?void n(t):void i.deleteAllModels(e,function(i){return i?(e.run("ROLLBACK"),void n(i)):void e.run("DELETE FROM sqlite_sequence WHERE name = 'models'",function(i){return i?(e.run("ROLLBACK"),void n(i)):void addModelList(e,r,function(r){e.run(r?"ROLLBACK":"COMMIT"),n(r)})})})})},exports.getModelList=function(e,r){var n="SELECT id, name, detail FROM models",i=[];e.serialize(function(){e.each(n,function(e,r){i.push({id:r.id,name:r.name,detail:JSON.parse(r.detail)})},function(e,n){r(e,i)})})},exports.getModelID=function(e,r,n){var i="SELECT id FROM models WHERE name = '"+r+"'";e.get(i,function(e,r){return e?void n(e,void 0):"undefined"==typeof r?void n(new Error("can not get model id."),void 0):void n(e,r.id)})},exports.getConfig=function(e,r,n){var i="SELECT val FROM settings WHERE id = ?",t=null;e.each(i,r,function(e,r){return e?void n(e):void(t=r.val)},function(e,r){n(e,t)})},exports.setConfig=function(e,r,n,i){var t="INSERT INTO settings(id, val) VALUES(?, ?)",a="UPDATE settings SET val = '"+n+"' WHERE id = '"+r+"'";this.getConfig(e,r,function(o,d){o?i(o):null==d||void 0==d?e.run(t,r,n,function(e){i(e)}):e.exec(a,function(e){i(e)})})},exports.importEMX=function(e,r,n,i,t,a,o){if(!regexp_emx.test(r))return void o(new Error("no model information."));var d=regexp_emx.exec(r),s=d[1],u=d[2],l={title:r,emxtitle:r,modelname:s,medianame:u},f=0,m=0,p=i.ID,c=this;this.getModelID(e,s,function(r,d){if(r)return void o(r);if("undefined"==typeof d)return void o(new Error("can not get model id"));f=d;var s=a;c.searchBankNoFromMediaID(e,"0",f,p,function(r,a){return r?void o(r):void(0==a.length?getNewBankNo(e,m,function(r,a){return r?void o(r):(s=a,null!=n&&(n.bankNo=String(s)),void setParams(e,f,m,s,p,0,l,n,i,t,function(e){o(e)}))}):(s=a[0].bank_no,console.log("[overwrite] bank_no = "+s+", media_id = "+p),null!=n&&(n.bankNo=String(s)),c.updateParams(e,f,m,s,0,l,n,i,t,function(e){o(e)})))})})},exports.deleteEMX=function(e,r,n){var i="SELECT value FROM params WHERE bank_no = ? AND printer_id = 0 AND param_type_id = 0";e.get(i,r,function(i,t){if(i)return console.error(i.message),void n(i);if(!t)return void n(new Error("EMX not found: bank_no = "+r));var a=getEmxDirName(t.value);exports.deleteEMXDir(a,function(e){e&&console.error(e.message)});var o="DELETE FROM params WHERE bank_no = ? AND printer_id = 0",d=e.prepare(o,r,function(e){return e?(console.error(e.message),void n(e)):void d.run(function(e){e&&console.error(e.message),d.finalize(),n(e)})})})},exports.deleteEMXDir=function(e,r){var n=getUserTemp(),i=path.join(n,e);rmdirAll(i,r)},exports.getMechaParamList=function(e,r,n,i){var t="SELECT detail FROM printers, models WHERE printers.id = ? AND printers.model_id = models.id",a="SELECT bank_no, value, param_type_id FROM params WHERE printer_id = ? AND (param_type_id = 1 OR param_type_id  = 0) ORDER BY bank_no";e.get(t,r,function(t,o){if(t)return void i(t);var d={},s=JSON.parse(o.detail);d.Base="undefined"==typeof o?{Model:"Media Library",SerialNumber:"none",Version:format_version,MakeTime:getCurrentTimes()}:{Model:s.Series,SerialNumber:r,Version:format_version,MakeTime:getCurrentTimes()};var u=0;e.each(a,r,function(e,r){if(e)return void i(e);if("undefined"==typeof r)return void i(new Error("no mecha param list"));var n=("0"+r.bank_no).slice(-2),t=JSON.parse(r.value);if(1==r.param_type_id){delete t.bankNo;var a;d["Setting"+n]&&(a=d["Setting"+n].MediaFullName),d["Setting"+n]=t,a&&(d["Setting"+n].MediaFullName=a),u++}else 0==r.param_type_id&&t&&t.MediaFullName&&(d["Setting"+n]={},d["Setting"+n].MediaFullName=t.MediaFullName)},function(e,r){return d.Base.SettingNum=String(u),"XML"!=n?void i(e,d):void to_xml(JSON.stringify(d),function(e,r){return e?void i(e):void i(e,r)})})})},exports.getImportedEMXList=function(e,r){var n="SELECT emxname.value AS emxname, emxjson.value AS emxjson FROM (SELECT * FROM params WHERE printer_id=0 and param_type_id=0 and media_id!=0) emxname INNER JOIN (SELECT * FROM params WHERE printer_id=0 and param_type_id=2 and media_id!=0) emxjson ON emxname.bank_no = emxjson.bank_no;",i=[];e.each(n,function(e,r){var n=getEmxDirName(r.emxname),t=JSON.parse(r.emxjson).TimeStamp,a={name:n,time_stamp:parseTimeStamp(t)};i.push(a)},function(e,n){r&&r(e,i)})};var getEmxDirName=function(e){var r=JSON.parse(e);return r.emxtitle||r},parseTimeStamp=function(e){var r=parseInt(e.substr(0,4),10),n=parseInt(e.substr(4,2),10),i=parseInt(e.substr(6,2),10),t=parseInt(e.substr(8,2),10),a=parseInt(e.substr(10,2),10);return new Date(Date.UTC(r,n-1,i,t,a))},traverse=function(e,r){var n=[];fs.readdir(e,function(i,t){if(i)return void r(i);var a=t.length;return a?void t.forEach(function(i){var t=path.join(e,i);if(fs.statSync(t).isDirectory())traverse(t,function(e,i){n=n.concat(i),--a||r(null,n)});else{var o=path.basename(t);n.push(o),--a||r(null,n)}}):r(null,n)})},rmdirAll=function(e,r){fs.readdir(e,function(n,i){if(n)return void r(n);var t=i.length,a=function(n){fs.rmdir(e,function(e){r(e)})};return t?void i.forEach(function(r){var n=path.join(e,r);fs.statSync(n).isDirectory()?rmdirAll(n,function(e){--t||a(e)}):fs.unlink(n,function(e){--t||a(e)})}):void a()})},mkdirAllSync=function(e,r,n){var i=e.split(/\\|\//),t=i.shift(),a=path.join(n||"",t);try{fs.mkdirSync(a,r||file_permission)}catch(o){if(!fs.statSync(a).isDirectory())throw new Error(o)}return!i.length||mkdirAllSync(i.join(path.sep),r,a)};exports.isNeedToRIDFiltering=function(e,r,n){return isNeedToRIDFiltering(e,r,n)},exports.filteringEmxJson=function(e){return filteringEmxJson(e)},exports.filteringAllPmi=function(e){return filteringAllPmi(e)};var getAllPrinterThreeLayerSupport=function(e,r){var n="SELECT id, firm_ver FROM printers",i={};e.each(n,function(e,n){if(e)return console.error(e.message),void r(e);var t=JSON.parse(n.firm_ver);i[n.id]=t.attributes.three_layers_media_print},function(e,n){r(e,i)})},isNeedToRIDFiltering=function(e,r,n){getAllPrinterThreeLayerSupport(e,function(e,i){var t;if(r){var a=i[r];t=a===!1}else{var o=!0;for(var d in i){var a=i[d];if(a){o=!1;break}}t=0!==Object.keys(i).length?o:!1}n(e,t)})},filteringEmxJson=function(e){var r={};for(var n in e.ModeInfo){var i=e.ModeInfo[n];"3"!==i.OnePassLayerNum&&(r[n]=i)}return e.ModeInfo=r,e},filteringAllPmi=function(e){if(!e.allPmi)return e;var r=e.allPmi.split(","),n=[];if(void 0!==e.ModeInfo.OnePassLayerNum)"3"!==e.ModeInfo.OnePassLayerNum&&n.push(e.ModeInfo.PMI);else for(var i in e.ModeInfo){var t=e.ModeInfo[i];"3"!==t.OnePassLayerNum&&n.push(t.PMI)}var a=r.filter(function(e,r){return n.some(function(r,n){return e===r})});return e.allPmi=a.join(","),e},addModelWithId=function(e,r,n,i,t,a){var o="INSERT INTO models(id, name, detail, note) VALUES(?, ?, ?, ?)",d=e.prepare(o,r,n,JSON.stringify(i),t,function(e){return e?void a(e):void d.run(function(e){a(e)})})},addModelList=function(e,r,n){if(0==r.length)return void n(null);var i=r.shift();addModelWithId(e,i.id,i.name,i.detail,i.note,function(i){return i?void n(i):void addModelList(e,r,n)})},getUserDoc=function(){var e;if("win32"==process.platform){var r=process.env.PUBLIC;void 0==r&&(r=process.env.ALLUSERSPROFILE),e=r+"/Documents/Epson/"+appname}else e="darwin"==process.platform?"/Library/Application Support/Epson/Epson "+appname:"/usr/share/Epson/Epson "+appname;return fs.existsSync(e)||fse.mkdirpSync(e,file_permission),e},getUserEmxDir=function(){var e;switch(process.platform){case"win32":case"darwin":e=getUserDoc();break;default:e=getUserDoc()+"/EMX"}return e},getLogDir=function(){var e;switch(process.platform){case"win32":case"darwin":e=getUserDoc();break;default:e="/var/lib/Epson/Epson "+appname}return e},getUserTemp=function(){var e;if("win32"==process.platform){var r=process.env.ALLUSERSPROFILE;e=r+"/Epson/",fs.existsSync(e)||fs.mkdirSync(e,file_permission),e+=appname}else e="darwin"==process.platform?"/Library/Application Support/Epson/":"/var/lib/Epson/",fs.existsSync(e)||fs.mkdirSync(e,file_permission),e+="ECD Program Data";return fs.existsSync(e)||fs.mkdirSync(e,file_permission),e},copyEmx=function(e,r){var n=getUserEmxDir(),i=regexp_zip.exec(e),t=i[1];if(!regexp_emx.test(t))return console.error("no model information."),void(r&&r(new Error("no model information.")));var a=regexp_emx.exec(t),o=a[1],d=(a[2],n+"/"+o);fs.existsSync(d)||fs.mkdirSync(d,file_permission);var s=d+"/"+t+".emx";fse.copy(e,s,function(e){e&&console.error(e.message),r&&r(e)})},getModelName=function(e,r,n){var i="SELECT name FROM models WHERE id = "+r;e.get(i,function(e,r){return e?(console.error(e.message),void n(e,void 0)):"undefined"==typeof r?void n(new Error("can not get model name."),void 0):void n(e,r.name)})},setParams=function(e,r,n,i,t,a,o,d,s,u,l){console.log("model id = "+r+", serial no = "+n+", media ID = "+t+", bank no = "+i),addParam(e,r,n,i,t,0,o,function(a){return a?void console.error(a):void addParam(e,r,n,i,t,1,d,function(a){return a?void console.error(a):void addParam(e,r,n,i,t,2,s,function(a){return a?void console.error(a):void addParam(e,r,n,i,t,3,u,function(e){return e?void console.error(e):void l(e)})})})})},addNewPrinter=function(e,r,n,i,t,a,o,d,s,u){var l="INSERT INTO printers(id, model_id, name, que_name, net_config, firm_ver, note, sort_id ) VALUES(?, ?, ?, ?, ?, ?, ?, ?)",f=e.prepare(l,n,r,i,t,JSON.stringify(a),JSON.stringify(o),d,s,function(e){return e?void u(e):void f.run(function(e){f.finalize(),u(e)})})},getNewBankNo=function(e,r,n){var i="SELECT bank_no FROM params where printer_id = "+r+" AND param_type_id = 0";e.all(i,function(e,r){if(e)return void n(e,void 0);if("undefined"==typeof r)return void n(new Error("can't get new bank no"));{var i=r.length;r.map(function(e,r){return e.bank_no}).sort(function(e,r){return e-r}).some(function(e,r){return e!==r?(i=r,!0):!1})}return void n(e,i)})},addParam=function(e,r,n,i,t,a,o,d){var s="INSERT INTO params(model_id, printer_id, bank_no, media_id, param_type_id, value) VALUES( ?, ?, ?, ?, ?, ?)",u=e.prepare(s,r,n,i,t,a,JSON.stringify(o),function(e){return e?(console.error(e.message),void d(e)):void u.run(function(e){e&&console.error(e.message),u.finalize(),d(e)})})},updateParam=function(e,r,n,i,t,a,o){if(!a)return o(null);var d;0==r?(d="UPDATE params SET value = ? WHERE printer_id = ? AND bank_no = ? AND param_type_id = ?",e.run(d,JSON.stringify(a),n,i,t,function(e){return e?(console.error(e.message),void o(e)):void o(e)})):(d="UPDATE params SET value = ? WHERE model_id = ? AND printer_id = ? AND bank_no = ? AND param_type_id = ?",e.run(d,JSON.stringify(a),r,n,i,t,function(e){return e?(console.error(e.message),void o(e)):void o(e)}))},createDummyBanks=function(e,r,n,i){for(var t="INSERT INTO params VALUES ",a="",o=1;30>=o;o++)for(var d=0;4>d;d++){var s;1==d?s={Setting01:{No:"1",MediaName:{_:"no name"}}}:2==d?s={version:"1",mpsname:"",MediaName:{_:"no name"},ID:""}:3==d&&(s={}),a+=1==d?"("+r+", '"+n+"', "+o+", '0', "+d+", '"+JSON.stringify(s)+"' ),":"("+r+", '"+n+"', "+o+", '0', "+d+", NULL ),"}t+=a,t=t.replace(/\,$/g,""),e.run(t,function(e){e&&console.error(e.message),i(e)})},deletePrinterStatus=function(e,r,n){var i="DELETE FROM statuses WHERE printer_id = '"+r+"'";e.run(i,function(e){n(e)})},deleteParams=function(e,r,n){var i="DELETE FROM params WHERE printer_id = '"+r+"'";e.run(i,function(e){n(e)})},extend=function(e){var r=[].slice.call(arguments,1);return r.forEach(function(r){for(var n in r)e[n]=r[n]}),e},getCurrentTimes=function(){var e=new Date,r=e.getFullYear()+"/"+("0"+(e.getMonth()+1)).slice(-2)+"/"+("0"+e.getDate()).slice(-2),n=e.getHours(),i=e.getMinutes(),t=e.getSeconds();return r+" "+n+":"+i+":"+t};