var nm=require("./NativeProcessManager"),sm=require("./PrinterStatusManager"),emxParser=require("../emxParser/index"),dbManager=emxParser.dbManager,PrinterInfo=emxParser.types.Common.UITypes.PrinterInfo,config=require("../config/index"),qlog=require("../logger/index"),customError_1=require("../customError"),PrinterGroup=function(){function e(e){var r=this;this.epson="EPSON ",this._native=e,this.unregisteredList=new Array,dbManager.getModelList(function(e,t){qlog.info("Model List:\n"+JSON.stringify(t,null,2)),r.modelList=t}),this.GetRegisteredPrinter(function(e,r){qlog.info("Printer List:\n"+JSON.stringify(r,null,2))}),this.StartAllPrinter()}return e.prototype.GetDiscoveredPrinter=function(){return this.unregisteredList},e.prototype.GetRegisteredPrinter=function(e){dbManager.getPrinterList(e)},e.prototype.GetRegisteredPrinterEx=function(e,r){var t=this;dbManager.getPrinterList(function(n,i){var o=new Array;t.GetStatusAll(e,o,i,r)})},e.prototype.GetStatusAll=function(e,r,t,n){var i=this;if(0===t.length)return void(n&&n(null,r));var o=t.shift();dbManager.getPrinterStatus(o.serial,function(a,s){var l=sm.PrinterStatusManager.ConvertToUIStatus(s.status),u=s.statusRaw,f=o;f.status=l,f.datetime=s.datetime,f.attributes=s.attributes||{monitoring:!0},f.cleaningInfo=s.cleaningInfo?i.calcCleaningInfo(s.cleaningInfo,u):null,f.cleaningNoticeInfo=s.cleaningNoticeInfo||null,f.mediaAmountUsed=s.mediaAmountUsed||null;for(var d=0;d<e.length;d++)switch(e[d]){case"errors":f.errors=s.allErrors||[];break;case"warnings":f.warnings=s.warning||[];break;case"inkstates":f.inkstates=s.inkSlotInfo||s.inkInfo||[]}r.push(f),i.GetStatusAll(e,r,t,n)})},e.prototype.calcCleaningInfo=function(e,r){var t={};return null===e.requiredTime||7!==r&&18!==r?t.remainingTimeToCleaning=e.remainingTimeToCleaning:(t.progress=e.current/e.operationTime*100,t.isCleaning=7===r),t},e.prototype.RegisterPrinterDB=function(e,r){var t=this,n=this.modelList.filter(function(r,t){return r.name==e.modelName});if(0===n.length)r(new Error("Model not found"));else{var i=n[0].id;dbManager.addPrinter(i,e.serial,e.name,e.queueName,{IP:e.IP},e.firmFullInfo,"comment",e.tabId,function(n){n?r(n):(qlog.info("Register Printer:\n"+JSON.stringify(e,null,2)),sm.PrinterStatusManager.SetOffline(e.serial,function(e){}),t._native.StartPrinter(e.queueName,e.serial,function(e,r){e&&qlog.error("error: "+e+r)}),r(n))})}},e.prototype.UnregisterPrinter=function(r,t){var n=this;e.getQueueNameBySerial(r,function(e,i){dbManager.deletePrinter(r,function(e){e?t(e):(qlog.info("Unregister Printer: "+r),n._native.EndPrinter(i,function(e,r){}),t(e))})})},e.prototype.RegisterPrinter=function(e,r){var t=this;this.GetRegisteredPrinter(function(n,i){if(e.name||(e.name=e.queue),e.detail)t.registerCore(e,i,r);else{var o=i.filter(function(r,t){return r.queueName===e.queue});if(o.length>0)return r(new customError_1.ApiError("Already registered.",409));t._native.SearchPrinter(e.queue,function(n,o){if(n)return r(new customError_1.ApiError("Printer not found: "+n.message));if(o.model.indexOf(t.epson)<0)return r(new customError_1.ApiError("Invalid model."));var a=o.model.substr(t.epson.length),s=t.modelList.filter(function(e,r){return e.detail.Series==a});e.detail={model:s[0].name,serial:o.status.serial,ip:o.ip,firm:o.firmVersion},t.registerCore(e,i,r)})}})},e.prototype.registerCore=function(e,r,t){var n=this,i=r.some(function(r,t){return r.serial===e.detail.serial}),o=r.filter(function(r,t){return r.tabId==e.tab&&r.serial!==e.detail.serial});if(null===e.tab||void 0===e.tab){var a=r.map(function(e){return e.tabId}),s=this.getEmptyIndex(a);if(!(4>s))return t(new customError_1.ApiError("Can't register printer."));e.tab=s}var l=function(){if(i){var r=e.detail.serial&&e.detail.firm;if(!r)return t(new Error("PrinterUpdate Param Error"));dbManager.updatePrinter(e.detail.serial,e.name,{IP:e.detail.ip},e.detail.firm,null,e.tab,function(e){t(e)})}else{var r=e.detail.serial&&e.queue&&e.detail.model&&e.detail.firm;if(!r)return t(new Error("PrinterUpdate Param Error"));var o=new PrinterInfo(e.detail.serial,e.name,e.queue,e.detail.ip,e.detail.model,null,e.detail.firm,e.tab);n.RegisterPrinterDB(o,function(e){t(e)})}};o.length>0?this.RemovePrinters(o,function(e){l()}):l()},e.prototype.getEmptyIndex=function(e){if(!e)return 0;var r=e.filter(function(e,r,t){return t.indexOf(e)===r}).sort(function(e,r){return e-r}),t=r.filter(function(e,r){return e!==r});return 0!==t.length?r.indexOf(t[0]):r.length},e.prototype.RemovePrinters=function(e,r){var t=this;if(0===e.length)return void(r&&r(null));var n=e.shift();this.UnregisterPrinter(n.serial,function(n){t.RemovePrinters(e,r)})},e.prototype.DiscoverPrinter=function(){var e=this;if(!this.isDescovering){this.isDescovering=!0,this.unregisteredList=new Array;var r=config.get("registration"),t=r&&r.additionalIpList&&r.additionalIpList.length>0,n=t?r.additionalIpList:null;this._native.DiscoverPrinter(n,function(e,r){qlog.error("DiscoverPrinter error:\n"+JSON.stringify(e,null,2))}),this._native.on(nm.EventTypes.PrinterDiscovered,function(r,t,n){if(qlog.trace("PrinterDiscovered"),!(t.model.indexOf(e.epson)<0)){var i=t.model.substr(e.epson.length),o=null;for(var a in e.modelList)if(e.modelList[a].detail.Series===i){o=e.modelList[a].name;break}o&&(qlog.info("Discovered Printer: "+r+"  ("+t.status.serial+")"),qlog.trace(JSON.stringify(t)),e.GetRegisteredPrinter(function(n,a){if(!n){var s="",l=a.filter(function(e,r){return e.serial===t.status.serial});s=0!=l.length?l[0].name:"win32"===process.platform?r:i+":"+t.status.serial;var u=new PrinterInfo(t.status.serial,s,r,t.ip,o,i,t.firmVersion,0);delete u.tabId,e.unregisteredList.push(u)}}))}}),this._native.on(nm.EventTypes.EndDiscoverPrinter,function(r,t,n){qlog.trace("EndDiscoverPrinter"),e._native.removeAllListeners(nm.EventTypes.PrinterDiscovered),e._native.removeAllListeners(nm.EventTypes.EndDiscoverPrinter),e.isDescovering=!1})}},e.prototype.IsCompleted=function(){return!this.isDescovering},e.prototype.StartAllPrinter=function(){var e=this;this.GetRegisteredPrinter(function(r,t){for(var n=0;n<t.length;n++)sm.PrinterStatusManager.SetOffline(t[n].serial,function(e){}),e._native.StartPrinter(t[n].queueName,t[n].serial,function(e,r){e&&qlog.error("error: "+e+r)})})},e.prototype.EndAllPrinter=function(e){var r=this;this.GetRegisteredPrinter(function(t,n){var i=n.length;if(i>0)for(var o=0;i>o;o++){var a=function(r){return function(t,n){t&&qlog.error("error: "+t+n),r&&e&&e()}};r._native.EndPrinter(n[o].queueName,a(o===i-1))}else e&&e()})},e.getQueueNameBySerial=function(e,r){dbManager.getPrinterList(function(t,n){var i=n.filter(function(r,t){return r.serial===e?!0:void 0});0!=i.length&&null!==i[0].queueName&&void 0!==i[0].queueName?r(null,i[0].queueName):r(new Error("Not Found"),null)})},e.getSerialByQueueName=function(e,r){dbManager.getPrinterList(function(t,n){var i=n.filter(function(r,t){return r.queueName===e?!0:void 0});0!=i.length&&null!==i[0].serial&&void 0!==i[0].serial?r(null,i[0].serial):r(new Error("Not Found"),null)})},e}();exports.PrinterGroup=PrinterGroup;